QGIS Application - Bug report #10470
QGIS-Server wrong legend generation if scale parameter is present
2014-06-05 05:15 AM - aperi2007 -

Status: Closed

Priority: Severe/Regression

Assignee: Marco Hugentobler

Category: QGIS Server

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 18882
Description

Hi,

I'm testing the qgis-server from trunk version.

| see that the legend graphics return from a GetLegendGraphics request if truncate if there the scale parameter.
some samples:

thsi is is with scale parameter:

http://www502.regione.toscana.it/geoscopio qg/cgi-bin/qgis _mapserv?map=continuum_geologico rt.qgs&#38;SERVICE=WMS&#38;r
quest=GetLegendGraphic&#38;version=1.1.1&#38;format=image/png&#38;sld version=1.1.0&#38;width=23&#38;height=158&#38;layer=

rane&#

frane&#38;style=default&#38;legend options=fontName:Verdana;fontSize:10&#38;scale=7927.372584308516

And this is the same without the scale parameter.
http://www502.regione.toscana.it/geoscopio_qg/cgi-bin/qgis _mapserv?map=continuum_geologico rt.qgs&#38;SERVICE=WMS&#38;r
quest=GetLegendGraphic&#38;version=1.1.1&#38;format=image/png&#38;sld version=1.1.0&#38;width=23&#38;height=15&#38;layer=

rane&#

frane&#38;style=default&#38;legend options=fontName:Verdana;fontSize:10&#38;scale=7927.372584308516

Regards,

Andrea.

History

#1 - 2014-06-05 05:21 AM - aperi2007 -

oops, the second was always with scale parameter.
this is really without scale parameter:

www502.regione.toscana.it/geoscopio_qgg/cgi-bin/qgis_mapserv?map=continuum_geologico_rt.qgs&SERVICE=WMS&request=GetLegendGraphic&ver
ion=1.1.1&format=image/png&sld_version=1.1.0&width=23&height=15&layer=frane&style=default&legend_options=fontName:Verdana;fontSize:10

#2 - 2014-06-05 05:22 AM - Giovanni Manghi
- Category set to QGIS Server
- Affected QGIS version changed from 2.2.0 to master

why blocker? it used to work in previous qgis releases?

2025-06-13 1/4


http://www502.regione.toscana.it/geoscopio_qg/cgi-bin/qgis_mapserv?map=continuum_geologico_rt.qgs&#38;SERVICE=WMS&#38;request=GetLegendGraphic&#38;version=1.1.1&#38;format=image/png&#38;sld_version=1.1.0&#38;width=23&#38;height=15&#38;layer=frane&#38;style=default&#38;legend_options=fontName:Verdana;fontSize:10&#38;scale=7927.372584308516
http://www502.regione.toscana.it/geoscopio_qg/cgi-bin/qgis_mapserv?map=continuum_geologico_rt.qgs&#38;SERVICE=WMS&#38;request=GetLegendGraphic&#38;version=1.1.1&#38;format=image/png&#38;sld_version=1.1.0&#38;width=23&#38;height=15&#38;layer=frane&#38;style=default&#38;legend_options=fontName:Verdana;fontSize:10&#38;scale=7927.372584308516
http://www502.regione.toscana.it/geoscopio_qg/cgi-bin/qgis_mapserv?map=continuum_geologico_rt.qgs&#38;SERVICE=WMS&#38;request=GetLegendGraphic&#38;version=1.1.1&#38;format=image/png&#38;sld_version=1.1.0&#38;width=23&#38;height=15&#38;layer=frane&#38;style=default&#38;legend_options=fontName:Verdana;fontSize:10&#38;scale=7927.372584308516
http://www502.regione.toscana.it/geoscopio_qg/cgi-bin/qgis_mapserv?map=continuum_geologico_rt.qgs&#38;SERVICE=WMS&#38;request=GetLegendGraphic&#38;version=1.1.1&#38;format=image/png&#38;sld_version=1.1.0&#38;width=23&#38;height=15&#38;layer=frane&#38;style=default&#38;legend_options=fontName:Verdana;fontSize:10&#38;scale=7927.372584308516
http://www502.regione.toscana.it/geoscopio_qg/cgi-bin/qgis_mapserv?map=continuum_geologico_rt.qgs&#38;SERVICE=WMS&#38;request=GetLegendGraphic&#38;version=1.1.1&#38;format=image/png&#38;sld_version=1.1.0&#38;width=23&#38;height=15&#38;layer=frane&#38;style=default&#38;legend_options=fontName:Verdana;fontSize:10&#38;scale=7927.372584308516
http://www502.regione.toscana.it/geoscopio_qg/cgi-bin/qgis_mapserv?map=continuum_geologico_rt.qgs&#38;SERVICE=WMS&#38;request=GetLegendGraphic&#38;version=1.1.1&#38;format=image/png&#38;sld_version=1.1.0&#38;width=23&#38;height=15&#38;layer=frane&#38;style=default&#38;legend_options=fontName:Verdana;fontSize:10&#38;scale=7927.372584308516

#3 - 2014-06-06 08:11 AM - Marco Hugentobler

- Assignee set to Marco Hugentobler

#4 - 2014-06-06 09:00 AM - aperi2007 -

| confirm it was also on QGIS 2.2,
but now is more badly.

Infact This is a sample from qgis-server 2.2:

QGIS 2.2 With scale parameter:
http://www502.regione.toscana.it/wmsraster2/qgis/wms?map=/maps/zz_contgeo.qgs&#38;SERVICE=WMS&#38;request=GetLegendGraphic&#38;versi
n=1.1.1&#38;format=image/png&#38;sld_version=1.1.0&#38;width=23&#38;height=15&#38;layer=franacart&#38;style=default&#38;legend options=fontName:Ve
Name:Verdana;fontSize:10&#38;scale=7927.372584308516

QGIS 2.2 without the scale parameter:
http://www502.regione.toscana.it/wmsraster2/qgis/wms ?map=/maps/zz_contgeo.qgs&#38;SERVICE=WMS&#38;request=GetLegendGraphic&#38;versi
n=1.1.1&#38;format=image/png&#38;sld version=1.1.0&#38;width=23&#38;height=15&#38;layer=franacart&#38;style=default&#38;legend options=fontName:Ve

Name:Verdana;fontSize:10

As yiu can see it break on the last domain.
So the user can effectlively see something , and all doamins are more or less visible.

INSTEAD
in qgis 2.4 this is the situation:

QGIS 2.4 with scale parameter:

http://www502.regione.toscana.it/geoscopio _qg/cgi-bin/qgis_mapserv?map=continuum_geologico_rt.qgs&#38;SERVICE=WMS&#38;request=GetLegen
Graphic&#38;version=1.1.1&#38;format=image/png&#38;sld_version=1.1.0&#38;width=23&#38;height=15&#38;layer=frane&#38;style=defaulti&#38;legend optior
nd_options=fontName:Verdana;fontSize:10&#38;scale=7927.372584308516

QGIS 2.4 without the scale parameter:
http://www502.regione.toscana.it/geoscopio _qg/cgi-bin/ggis mapserv?map=continuum_geologico rt.qgs&#38;SERVICE=WMS&#38;request=GetLegen
Graphic&#38;version=1.1.1&#38;format=image/png&#38;sld _version=1.1.0&#38;width=238&#38;height=15&#38;layer=frane&#38;style=default&#38;legend optior

nd_options=fontName:Verdana;fontSize:10

As you can see on QGIS 2.4 it lost fully two domains and a third is half.

So the QGIS 2.4 situation is worst than QGIS 2.2.

guess the Legend readability is an important question for a GIS system.
And | guess this is a worst question.

Of course this is only my opinion.

But effectively this is not a blocking question because as a workaround,

| could add two fake domains to be the last two values and invisibles (all white) to enlarge the image and retrieve so the two lost.
)

Regards,

Andrea.
#5 - 2014-06-12 07:34 AM - Marco Hugentobler
- Status changed from Open to Feedback

What is the style of the layer (rule based renderer?), could you attach a .gml file?

#6 - 2014-06-12 08:45 AM - aperi2007 -

Is a categorized rendering.

The QML of that image is quite complex because has a dual level rendering for every domains and with a point pattern inside using SVGs.

and also a data-definition use for rotation of patterns and also an expression controlled color border.

I will try to test and reproduce the bug on a more simple gml.

#7 - 2014-06-12 08:57 AM - aperi2007 -

- File depositisuperficiali.zip added

Hi.

| confirm the problem is also with more simple gml.

This as example:
With the scale parameter the last domains are lost.

http://www502.regione.toscana.it/geoscopio _qg/cgi-bin/qgis_mapserv?map=continuum_geologico_rt.qgs&#38;SERVICE=WMS&#38;request=GetLegen
Graphic&#38;version=1.1.1&#38;format=image/png&#38;sld_version=1.1.0&#38;width=238&#38;height=15&#38;layer=depositisuperficiali&#38;style=default&#38;|
ult&#38;legend_options=fontName:Verdana;fontSize:10&#38;scale=7927.372584308516

The gmis of this legend map is more simple than other and | can share the QML.
| attach it to this thread.

Regards,

Andrea.

#8 - 2014-06-12 09:15 AM - Marco Hugentobler

Ok, | imported the gml to my simple test project (layer does not match, but it does not matter for LegendGraphic). Issuing the example request (only map

and layer params replaced), | get the full legend with and without scale parameter.

I've committed a fix for a crash about an hour ago. Are you also working with that version (d8a0361febf6a52cd47bfca8f753afbf2d0bd153) ? Though |

cannot see how that fix would have any influence on the size of the generated image...

#9 - 2014-06-12 10:00 AM - aperi2007 -

ok,
Yes | confirm.
| have update the server to the last updates truk and the ussue is disappeared.

Thx Marco,

#10 - 2014-06-12 10:02 AM - Giovanni Manghi
- Resolution set to fixed/implemented
- Status changed from Feedback to Closed

Files
depositisuperficiali.zip 3.94 KB 2014-06-12 aperi2007 -
